\documentclass[a4paper,notitlepage,oneside,]{article}
\usepackage[a4paper,margin=2.54cm]{geometry}
\usepackage[T1]{fontenc}
\usepackage[sfdefault,scaled=.85]{FiraSans}
\usepackage{newtxsf}
\usepackage{framed}
\usepackage{xcolor}
%
\usepackage{hyperref}
\usepackage[acronym,toc]{glossaries}
\usepackage{parskip}
\usepackage{graphicx}
\usepackage{tabularx}
\usepackage{float}
\usepackage{enumitem}
\usepackage{fancyhdr}
\begin{document}
\frenchspacing
\pagestyle{fancyplain}
\renewcommand{\footrulewidth}{0.4pt}
\fancyhf{}
\fancyhf[HLE,HLO]{Experiment 3a - Comparing Received Prefixes}
\fancyhf[HRE,HRO,FRE,FRO]{\thepage}
\fancyhf[FLE,FLO]{DE-CIX Academy}
\fancyhf[FCE,FCO]{BGP for networks who peer}
\title{Experiment 3a - Comparing Received Prefixes}
\date{Version 2.1 - Students Copy - \today}
\author{\href{mailto:academy@decix.net}{DE-CIX Academy}}
\maketitle
\section{Introduction}
In this experiment you will receive some prefix announcements. Figure out why the one selected as ``best'' prefix is considered best by your router.

\section{Network Setup}
\begin{figure}[htp]
  \centering
  \includegraphics[width=\linewidth,page=1]{img/03-bestpath-drawings.pdf}
  \caption{Network Setup}
  \label{fig:networksetup}
\end{figure}
Figure \ref{fig:networksetup} shows the network topology for this experiment.
It is the same as for experiment 2.
All participants are using AS64501 upwards and are connected to AS65550, AS64496 (and if required to AS286 for peering).

\section{Experiments}
You are sent various prefixes via your configured peering connections.

\subsection{Tasks:}
\begin{itemize}
  \item Gather information about what you receive
  \item Explain why one of the announcement is selected as ``best'' by your router.
\end{itemize}

\subsubsection{Commands you need:}
\begin{description}
  \item[show bgp ipv4] lists all prefixes in the BGP table.
  \item[show bgp ipv4 \emph{<prefix>}] lists prefix \emph{<prefix>} including all details the router uses to make its best path selection.
  \item[show bgp ipv4 summary] lists all neighbors and the number of prefixes they announce
  \item[show bgp ipv4 neighbor \emph{<address>} routes] shows the accepted prefixes from neighbor \emph{<address>}
  \item[show bgp ipv4 neighbor \emph{<address>} received-routes] shows all  prefixes from neighbor \emph{<address>}, even the ones filtered out
\end{description}
Remark: The commands are the same for IPv6 - just use \emph{ipv6} instead of \emph{ipv4}.

\subsection{Configuration commands to influence best path selection}
These commands have to be entered in configuration mode ("conf term") and in context of the BGP router ("router bgp 645xx").

\subsubsection{AS path length}
\begin{description}
  \item[bgp bestpath as-path ignore] disables the use of the AS path length as criterium for best path selection. Do not use.
\end{description}

\subsubsection{MED}
\begin{description}
  \item[bgp always-compre-med] this enables the comparison of MEDs if the first AS in the AS path is \emph{not} the same. Use with care.
  \item[bgp bestpath missing-as-worst] changes the default behavior that a missing MED attribute is treated as \emph{best} - now a missing MED is treated as \emph{worst}.
\end{description}

\subsection{Multipath}
Sometimes you want more than one ``best prefix'' in your routing table. For this you can enable ``bgp multipath''.
\begin{description}
  \item[maximum-paths \emph{number}] in address family context configures that up to \emph{number} paths to one destination can be installed in the routing table.
  \item[bgp bestpath as-path ignore] skips the comparison of as-path length in the best-path selection (and allows multiple paths with different as-path length to be used).
  \item[bgp bestpath as-path multipath-relax] allows multiple paths with different neighbor ASes to be installed in the routing table.
\end{description}


\section{Slides}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Best Path Selection:\\Local Preference}
\Huge

\begin{framed}
\begin{enumerate}
  \item \textbf{Local Preference: Higher wins}
  \item AS-Path length: Shorter wins
  \item Origin Type: \emph{IGP} over \emph{EGP} over \emph{Incomplete}
  \item MED: Lower wins
  \item eBGP, iBGP: eBGP wins
  \item Age of route: Older wins
  \item Router ID: Lowest wins
  \item Neighbor IP address: Lowest wins
\end{enumerate}
\end{framed}

\vspace{0.5cm}

\begin{tabular}{|l|l|}
  \hline
  80.81.192.1 & Peer \\
  \hline
  10.230.xx.1 & Upstream \\
  \hline
  10.200.xx.1 & Upstream\\
  \hline
\end{tabular}
\vspace{0.5cm}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \item show bgp ipv4 129.13.0.0
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Best Path Selection:\\AS path length}
\Huge

% \vspace{1cm}

\begin{framed}
\begin{enumerate}
  \item Local Preference: Higher wins
  \item \textbf{AS-Path length: Shorter wins}
  \item Origin Type: \emph{IGP} over \emph{EGP} over \emph{Incomplete}
  \item MED: Lower wins
  \item eBGP, iBGP: eBGP wins
  \item Age of route: Older wins
  \item Router ID: Lowest wins
  \item Neighbor IP address: Lowest wins
\end{enumerate}
\end{framed}

\vspace{1cm}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \item show bgp ipv4 129.13.0.0
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Best Path Selection:\\Origin Type}
\Huge

\begin{framed}
\begin{enumerate}
  \item Local Preference: Higher wins
  \item AS-Path length: Shorter wins
  \item \textbf{Origin Type: \emph{IGP} over \emph{EGP} over \emph{Incomplete}}
  \item MED: Lower wins
  \item eBGP, iBGP: eBGP wins
  \item Age of route: Older wins
  \item Router ID: Lowest wins
  \item Neighbor IP address: Lowest wins
\end{enumerate}
\end{framed}

\vspace{0.5cm}
\begin{tabular}{|c|l|p{12cm}|}
  \hline
  i & IGP & Injected using \emph{network} statement\\
  \hline
  \textcolor{gray}{e} & \textcolor{gray}{EGP} & \textcolor{gray}{Injected from EGP (obsolete)}\\
  \hline
  ? & Incomplete & Injected using \emph{redistribute} from other routing protocol\\
  \hline
\end{tabular}
\vspace{0.5cm}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \item show bgp ipv4 129.13.0.0
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Best Path Selection:\\Multi Exit Discriminator (MED)}
\Huge

\begin{framed}
\begin{enumerate}
  \item Local Preference: Higher wins
  \item AS-Path length: Shorter wins
  \item Origin Type: \emph{IGP} over \emph{EGP} over \emph{Incomplete}
  \item \textbf{MED: Lower wins}
  \item eBGP, iBGP: eBGP wins
  \item Age of route: Older wins
  \item Router ID: Lowest wins
  \item Neighbor IP address: Lowest wins
\end{enumerate}
\end{framed}

\vspace{0.5cm}
\begin{center}
  \textbf{MED is only compared if the first AS in the path is the same!}
\end{center}
\vspace{0.5cm}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \item show bgp ipv4 193.141.4.0
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Best Path Selection:\\Older (more stable) prefix wins}
\Huge


\begin{framed}
\begin{enumerate}
  \item Local Preference: Higher wins
  \item AS-Path length: Shorter wins
  \item Origin Type: \emph{IGP} over \emph{EGP} over \emph{Incomplete}
  \item MED: Lower wins
  \item eBGP, iBGP: eBGP wins
  \item \textbf{ Age of route: Older wins}
  \item Router ID: Lowest wins
  \item Neighbor IP address: Lowest wins
\end{enumerate}
\end{framed}

\vspace{1cm}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \item show bgp ipv4 193.141.4.0
  \end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Best Path Selection:\\If own AS is in path, discard}
\Huge


\begin{framed}
\begin{enumerate}
  \item Local Preference: Higher wins
  \item AS-Path length: Shorter wins
  \item Origin Type: \emph{IGP} over \emph{EGP} over \emph{Incomplete}
  \item MED: Lower wins
  \item eBGP, iBGP: eBGP wins
  \item Age of route: Older wins
  \item Router ID: Lowest wins
  \item Neighbor IP address: Lowest wins
\end{enumerate}
\end{framed}

\vspace{1cm}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
  \item show bgp ipv4 neighbor 10.200.xx.1 received-routes
  \item show bgp ipv4 neighbor 10.200.xx.1 routes
  \end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Best Path Selection:\\General routing rules still take priority}
\Huge

% \vspace{1cm}

\begin{framed}
\begin{enumerate}
  \item Local Preference: Higher wins
  \item AS-Path length: Shorter wins
  \item Origin Type: \emph{IGP} over \emph{EGP} over \emph{Incomplete}
  \item MED: Lower wins
  \item eBGP, iBGP: eBGP wins
  \item Age of route: Older wins
  \item Router ID: Lowest wins
  \item Neighbor IP address: Lowest wins
\end{enumerate}
\end{framed}

\begin{framed}
  \textbf{0. More specific wins}
\end{framed}

Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
\end{itemize}
\end{samepage}
%----------------------------------------------------------------
\clearpage
\begin{samepage}
\subsection*{\Huge BGP Multipath:\\allow multiple paths into the BGP table}
\Large

% \vspace{1cm}

\begin{framed}
  \begin{verbatim}
  router bgp 645xx
   bgp bestpath as-path ignore
   bgp bestpath as-path multipath-relax
   address-family ipv4 unicast
     maximum-paths 2
   exit-address-family
   address-family ipv6 unicast
     maximum-paths 2
   exit-address-family
   \end{verbatim}
\end{framed}


Show commands:
\begin{itemize}
  \item show bgp ipv4 summary
  \item show bgp ipv4
\end{itemize}
\end{samepage}
%----------------------------------------------------------------



\end{document}
